<?php

/* Stolen code bit... */
function &last(&$array) {
	if (!count($array)) return null;
	end($array);
	return $array[key($array)];
}

function myParseXML(&$vals, &$dom, &$lev) {
   do {
       $curr = current($vals);
       $lev = $curr['level'];
       switch ($curr['type']) {
           case 'open':
               if (isset($dom[$curr['tag']])) {
                   $tmp = $dom[$curr['tag']];
                   if (!$tmp['__multi'])
                       $dom[$curr['tag']] = array('__multi' => true, $tmp);
                   array_push($dom[$curr['tag']], array());
                   $new =& last($dom[$curr['tag']]);
               } else {
                   $dom[$curr['tag']] = array();
                   $new =& $dom[$curr['tag']];
               }
               next($vals);
               myParseXML(&$vals, $new, $lev);
               break;
           case 'cdata':
               break;
           case 'complete':
               if (!isset($dom[$curr['tag']]))
                   $dom[$curr['tag']] = $curr['value'];
               else {
                   if (is_array($dom[$curr['tag']]))
                       array_push($dom[$curr['tag']] , $curr['value']);
                   else
                       array_push($dom[$curr['tag']] = array($dom[$curr['tag']]) , $curr['value']);
               }
               break;
           case 'close':
               return;
       }
   }
   while (next($vals)!==FALSE);
}

function MyXMLtoArray($XML) {
       $xml_parser = xml_parser_create();
       xml_parse_into_struct($xml_parser, $XML, $vals);
       xml_parser_free($xml_parser);
       reset($vals);
       $dom = array(); $lev = 0;
       myParseXML($vals, $dom, $lev);
       return $dom;
}

/* End stolen code :) */

function xml2array($file) {
	// hack to get the xml parser to read a file instead of a string.
	return MyXMLtoArray(file_get_contents($file));
}

function print_ut2004($gamedata, $ip) {
	   foreach ($gamedata as $entry[0] => $entry[1]) {
			# find mutators
			if (substr($entry[0], 0, 7) == "MUTATOR") {
				$flags .= "($entry[1]) ";
			}
		}

	echo '<table><tr><td colspan="2" style="border:1px #000 dotted;font-weight:bold">' . $gamedata['GAMENAME'] . ' (Version ' . $gamedata['SERVERVERSION'] . ')</td></tr>';

	echo '<tr><td>Server Name:</td><td>' . htmlentities($gamedata['SERVERNAME']) . '</td></tr>';
	echo '<tr><td>Gametype/Map:</td><td>' . $gamedata['GAMETYPE'] . ' in ' . $gamedata['GAMEMAP'] . '</td></tr>';

	echo '<tr><td>Current Players:</td><td>' . $gamedata['CURRENTPLAYERS'] . ' (of ' . $gamedata['MAXPLAYERS'] . ' Max)</td></tr>';
	echo '<tr><td>Mutators:</td><td>' . $flags . '</td></tr>'; 
	echo '<tr><td colspan="2"><a href="ut2004://' . $ip . ':' . $gamedata['PORT'] . '/">Join this Game</a></td></tr></table>';
	
}

function print_q3a($gamedata, $ip) {
	switch ($gamedata['GAMENAME']) {
		case "Call of Duty: United Offensive":
			$proto = "coduo"; break;
		case "Call of Duty":
			$proto = "cod"; break;
		default:
			$proto = "q3a"; break;
	}

   foreach ($gamedata as $entry[0] => $entry[1]) {
		# find flags
		if ($entry[1] == "1") {
			$flags .= "($entry[0]) ";
		}
	}

	echo '<table><tr><td colspan="2" style="border:1px #000 dotted;font-weight:bold">' . $gamedata['GAMENAME'] . ' (Version ' . $gamedata['SHORTVERSION'] . $gamedata['VERSION'] . ', Protocol Version ' . $gamedata['PROTOCOL'] . ')</td></tr>';

	echo '<tr><td>Server Name:</td><td>' . htmlentities($gamedata['SV_HOSTNAME']) . '</td></tr>';
	echo '<tr><td>Gametype/Map:</td><td>' . $gamedata['G_GAMETYPE'] . ' in ' . $gamedata['MAPNAME'] . '</td></tr>';

	echo '<tr><td>Max Players:</td><td>' . $gamedata['SV_MAXCLIENTS'] . '</td></tr>';
	echo '<tr><td>Flags:</td><td>' . $flags . '</td></tr>'; 
	echo '<tr><td colspan="2"><a href="' . $proto . '://' . $ip . ':' . $gamedata['PORT'] . '/">Join this Game</a></td></tr></table>';
}


?>
<html>
 <head>
  <title>Network Status</title>
  <style type="text/css">
  table {
   border: 1px #000 solid;
   width: 100%;
  }
  table td table {
   border: 1px #ff0 dotted;
   margin: 10px;
  }
  table td table td.first {
	width: 100px;
  }
  table th {
   border: 1px #000 solid;
  }
  body {
	color: #fff;
	background-color: #000;
	}
   td.highlight {
		font-weight:bold;
		background-color:#ff0;
		color:#000;
	}
  a:link {
		color: #77f;
  }
  </style>
  <META HTTP-EQUIV="Refresh" CONTENT="60">
 </head>

<?php
$stats = xml2array("/tmp/stats.xml");
$stats = $stats['STATS'];
?>
 <body>
  <h1>Network Status</h1>
  <p>Please note: links to <abbr title="Server Message Block">SMB</abbr>/<abbr title="Common Internet File System">CIFS</abbr> shares only work on Windows.  Because of security implications, the links do not work in Mozilla-based browsers by default.  Please <a href="http://kb.mozillazine.org/Firefox_:_Issues_:_Links_to_Local_Pages_Don't_Work">allow this site</a> to use links to local pages to over-ride this feature.</p>
  <p>This page was last updated: <code><?php echo $stats['UPDATED']; ?></code>.  This page will reload automatically every minute, and is updated every 5 minutes.</p>
  <table>
   <tr>
    <th>IP</th>
    <th>Name</th>
    <th>OS</th>
    <th>Server</th>
   </tr>
<?php
if ($stats['COMPUTER']['__multi'] == 1) {
	// there is more than one computer.
	$computercount = -1;
	$computers = $stats['COMPUTER'];
} else {
	$computercount = 0;
	$computers = $stats;
}

echo "\n\n<!--";
print_r($stats);
echo "-->\n\n";


foreach ($computers as $computer) {
	if ($computercount > -1) {
		echo '<tr>';
		echo '<td class="highlight">' . $computer['IP'] . '</td>';
		echo '<td class="highlight">' . $computer['NAME'] . '</td>';
		echo '<td>' . $computer['OS'] . '</td>';
		echo '<td>' . $computer['SERVER'] . '</td>';
		echo '</tr>';

		if ($computer['SHARES'] != 0) {
			// There are shares
			if ($computer['SHARES']['SHARE']['__multi'] == 1) {
				// this actually means there is > 1 share.
				$shares = $computer['SHARES']['SHARE'];
				$sharecount = -1;
			} else {
				$shares = $computer['SHARES'];
				$sharecount = 0;
			}

			echo '<tr><td colspan="4"><table>';

			foreach ($shares as $share) {
				if ($sharecount > -1) {
					if ($share['TYPE'] == 'smb') {
						// This will only work on win32
						echo '<tr><td class="first"><a href="file://///' . $computer['IP'] . '/' . $share['NAME'] . '/">' . $share['NAME'] . '</a></td><td>' . $share['COMMENT'] . '</td></tr>';
					} else if ($share['TYPE'] == 'ftp') {
						echo '<tr><td colspan="2"><a href="ftp://' . $computer['IP'] . '/">FTP Server</a></td></tr>';
					}

				}
				$sharecount++;
			}
			echo "</table></td></tr>";
		}

		if ($computer['GAMES'] != 0) {
			// There are games
			if ($computer['GAMES']['GAME']['__multi'] == 1) {
				// this actually means there is > 1 game
				$games = $computer['GAMES']['GAME'];
				$gamecount = -1;
			} else {
				$games = $computer['GAMES'];
				$gamecount = 0;
			}	
	
			echo '<tr><td colspan="4">';	
			foreach ($games as $game) {
				if ($gamecount > -1) {
					if ($game['TYPE'] == 'q3a') {
						// q3a-engine game
						print_q3a($game, $computer['IP']);
					} else if ($game['TYPE'] == 'ut2004') {
						// unreal tournament 2004/2003
						print_ut2004($game, $computer['IP']);
					}
				}
				$gamecount++;
			}
			echo "</td></tr>";
		}
	}
	$computercount++;
}

?>
</table>
<hr>
<p>Powered by ddrgen.  Please note that due to limitations of smbclient, only 10 shares per server are shown for SMB/CIFS.</p>
</body></html>
